unit Fileutil;

interface

uses SysUtils, WinTypes, WinProcs, Classes, Consts, FileCtrl;

type
  EInvalidDest = class(EStreamError);
  EFCantMove = class(EStreamError);


function GetFileSize(const FileName: string): LongInt;
function FileDateTime(const FileName: string): TDateTime;
function HasAttr(const FileName: string; Attr: Word): Boolean;
Procedure Execute(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer);


implementation

uses Forms, ShellAPI, TAUtils;

const
  SInvalidDest = 'Destination %s does not exist';
  SFCantMove = 'Cannot move file %s';



{ GetFileSize function }
{
  Returns the size of the named file without opening the file.  If the file
  doesn't exist, returns -1.
}

function GetFileSize(const FileName: string): LongInt;
var
  SearchRec: TSearchRec;
begin
  if FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec) = 0 then
    Result := SearchRec.Size
  else Result := -1;
end;

function FileDateTime(const FileName: string): System.TDateTime;
begin
  Result := FileDateToDateTime(FileAge(FileName));
end;

function HasAttr(const FileName: string; Attr: Word): Boolean;
begin
  Result := (FileGetAttr(FileName) and Attr) = Attr;
end;

Procedure Execute(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer);
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
   ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

end.
